package com.sd.business.controller.sku;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sd.business.entity.sku.vo.SkuClassifyVo;
import com.sd.business.entity.sku.dto.SkuClassifySelectDto;
import com.sd.business.entity.sku.dto.SkuClassifyDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.sd.business.service.sku.SkuClassifyService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * <p>
 * sku分类 前端控制器
 * </p>
 *
 * @author 
 * @since 2023-07-03
 */
@RestController
@RequestMapping("/skuClassify")
public class SkuClassifyController {

    @Autowired
    private SkuClassifyService skuClassifyService;

    /**
     * sku分类列表
     */
    @PostMapping("/list")
    public List<SkuClassifyVo> list() {
        return skuClassifyService.getList();
    }

    /**
     * sku分类分页
     */
    @PostMapping("/page")
    public Page<SkuClassifyVo> page(@RequestBody SkuClassifySelectDto dto) {
        return skuClassifyService.getPage(dto);
    }

    /**
     * sku分类明细
     */
    @PostMapping("/detail")
    public SkuClassifyVo detail(@RequestBody BaseSelectDto dto) {
        return skuClassifyService.detail(dto.getId());
    }

    /**
     * sku分类新增
     */
    @PostMapping("/add")
    public void add(@RequestBody SkuClassifyDto skuClassifyDto) {
        skuClassifyService.add(skuClassifyDto);
    }

    /**
     * sku分类编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody SkuClassifyDto skuClassifyDto) {
        skuClassifyService.edit(skuClassifyDto);
    }

    /**
     * sku分类删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        skuClassifyService.delete(dto.getId());
    }

}
