package com.sd.business.service.bom.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.sd.business.entity.bom.dto.BomDto;
import com.sd.business.entity.bom.dto.BomSelectDto;
import com.sd.business.entity.bom.po.Bom;
import com.sd.business.entity.bom.vo.BomVo;
import com.sd.business.mapper.bom.BomMapper;
import com.sd.business.service.bom.BomService;
import org.springframework.stereotype.Service;


/**
 * <p>
 * bom 服务实现类
 * </p>
 *
 * @author
 * @since 2023-06-30
 */
@Service
public class BomServiceImpl extends ServiceImpl<BomMapper, Bom> implements BomService {

    @Override
    public Page<BomVo> getPage(BomSelectDto dto) {
        IWrapper<Bom> wrapper = getWrapper();
        wrapper.orderByDesc("b", Bom::getId);
        Page<BomVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public BomVo detail(Long id) {
        Bom Bom = this.getById(id);
        BomVo result = BeanUtil.toBean(Bom, BomVo.class);
        return result;
    }

    @Override
    public void add(BomDto bomDto) {
        this.save(bomDto);
    }

    @Override
    public void edit(BomDto bomDto) {
        this.updateById(bomDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
