package com.sd.business.service.sku.impl;

import com.sd.business.entity.sku.po.SkuClassify;
import com.sd.business.mapper.sku.SkuClassifyMapper;
import com.sd.business.service.sku.SkuClassifyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sd.business.entity.sku.vo.SkuClassifyVo;
import com.sd.business.entity.sku.dto.SkuClassifySelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.sd.business.entity.sku.dto.SkuClassifyDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.List;

/**
 * <p>
 * sku分类 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-07-03
 */
@Service
public class SkuClassifyServiceImpl extends ServiceImpl<SkuClassifyMapper, SkuClassify> implements SkuClassifyService {

    @Override
    public List<SkuClassifyVo> getList() {
        IWrapper<SkuClassify> wrapper = getWrapper();
        wrapper.orderByDesc("sc", SkuClassify::getId);
        List<SkuClassifyVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<SkuClassifyVo> getPage(SkuClassifySelectDto dto) {
        IWrapper<SkuClassify> wrapper = getWrapper();
        wrapper.orderByDesc("sc", SkuClassify::getId);
        Page<SkuClassifyVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public SkuClassifyVo detail(Long id) {
        SkuClassify SkuClassify = this.getById(id);
        SkuClassifyVo result = BeanUtil.toBean(SkuClassify, SkuClassifyVo.class);
        return result;
    }

    @Override
    public void add(SkuClassifyDto skuClassifyDto) {
        this.save(skuClassifyDto);
    }

    @Override
    public void edit(SkuClassifyDto skuClassifyDto) {
        this.updateById(skuClassifyDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
